diff -Naur moodle/lib/datalib.php moodle-conditionals/lib/datalib.php
--- moodle/lib/datalib.php	2009-01-14 23:06:56.000000000 +0000
+++ moodle-conditionals/lib/datalib.php	2009-09-16 13:38:34.000000000 +0100
@@ -1822,7 +1822,10 @@
  * @return bool
  */
 function coursemodule_visible_for_user($cm, $userid=0) {
-    global $USER;
+    /// START CONDITIONALS
+    //global $USER;
+    global $USER, $CFG;
+    /// END CONDITIONALS
 
     if (empty($cm->id)) {
         debugging("Incorrect course module parameter!", DEBUG_DEVELOPER);
@@ -1831,7 +1834,14 @@
     if (empty($userid)) {
         $userid = $USER->id;
     }
-    if (!$cm->visible and !has_capability('moodle/course:viewhiddenactivities', get_context_instance(CONTEXT_MODULE, $cm->id), $userid)) {
+
+    /// START CONDITIONALS
+    //if (!$cm->visible and !has_capability('moodle/course:viewhiddenactivities', get_context_instance(CONTEXT_MODULE, $cm->id), $userid)) {
+    require_once("$CFG->libdir/conditional.php");
+    $conditionalvisible = conditional_user_module_visible($cm->id, $userid);
+    if ((!$cm->visible || !$conditionalvisible) and !has_capability('moodle/course:viewhiddenactivities', get_context_instance(CONTEXT_MODULE, $cm->id), $userid)) {
+    /// END CONDITIONALS
+
         return false;
     }
     return groups_course_module_visible($cm, $userid);
diff -Naur moodle/lib/grade/grade_item.php moodle-conditionals/lib/grade/grade_item.php
--- moodle/lib/grade/grade_item.php	2009-04-23 01:07:33.000000000 +0100
+++ moodle-conditionals/lib/grade/grade_item.php	2009-09-16 13:38:34.000000000 +0100
@@ -563,7 +563,22 @@
      * @return boolean hidden state
      */
     function is_hidden() {
-        return ($this->hidden == 1 or ($this->hidden != 0 and $this->hidden > time()));
+
+        /// START CONDITIONALS
+        //return ($this->hidden == 1 or ($this->hidden != 0 and $this->hidden > time()));
+        global $CFG, $USER;
+
+        if ($this->itemtype == 'mod') {
+            $mod = get_record('modules', 'name', $this->itemmodule);
+            $cm = get_record('course_modules', 'course', $this->courseid, 'module',  $mod->id, 'instance', $this->iteminstance);
+            require_once("$CFG->libdir/conditional.php");
+            $conditionalvisibility = conditional_user_module_visible($cm->id, $USER->id);
+            return (!$conditionalvisibility or $this->hidden == 1 or ($this->hidden != 0 and $this->hidden > time()));
+        } else {
+            return ($this->hidden == 1 or ($this->hidden != 0 and $this->hidden > time()));
+        }
+        /// END CONDITIONALS
+
     }
 
     /**
diff -Naur moodle/lib/moodlelib.php moodle-conditionals/lib/moodlelib.php
--- moodle/lib/moodlelib.php	2009-05-15 10:14:16.000000000 +0100
+++ moodle-conditionals/lib/moodlelib.php	2009-09-16 13:38:34.000000000 +0100
@@ -1991,10 +1991,24 @@
             print_error('nocontext');
         }
     }
+
+    /// START CONDITIONALS
+    $conditionalvisible = true;
+    if(!empty($cm) && isset($cm->id)) {
+        require_once($CFG->libdir."/conditional.php");
+        $conditionalvisible = conditional_user_module_visible($cm->id, $USER->id);
+    }
+    /// END CONDITIONALS
+
     if ($COURSE->id == SITEID) {
         /// Eliminate hidden site activities straight away
-        if (!empty($cm) && !$cm->visible
-            && !has_capability('moodle/course:viewhiddenactivities', $cm->context)) {
+
+        /// START CONDITIONALS
+        //if (!empty($cm) && !$cm->visible
+        //    && !has_capability('moodle/course:viewhiddenactivities', $cm->context)) {
+        if (!empty($cm) && (!$cm->visible || !$conditionalvisible) && !has_capability('moodle/course:viewhiddenactivities', $cm->context)) {
+        /// END CONDITIONALS
+
             redirect($CFG->wwwroot, get_string('activityiscurrentlyhidden'));
         }
         user_accesstime_log($COURSE->id); /// Access granted, update lastaccess times
@@ -2040,7 +2054,12 @@
                         print_header_simple();
                         notice(get_string('guestsnotallowed', '', format_string($COURSE->fullname)), "$CFG->wwwroot/login/index.php");
                     }
-                    if (!empty($cm) and !$cm->visible) { // Not allowed to see module, send to course page
+
+                    /// START CONDITIONALS
+                    //if (!empty($cm) and !$cm->visible) { // Not allowed to see module, send to course page
+                    if (!empty($cm) and (!$cm->visible || !$conditionalvisible)) { // Not allowed to see module, send to course page
+                    /// END CONDITIONALS
+
                         redirect($CFG->wwwroot.'/course/view.php?id='.$cm->course,
                                  get_string('activityiscurrentlyhidden'));
                     }
@@ -2085,7 +2104,11 @@
 
         /// Make sure they can read this activity too, if specified
 
-            if (!empty($cm) && !$cm->visible && !has_capability('moodle/course:viewhiddenactivities', $cm->context)) {
+            /// START CONDITIONALS
+            //if (!empty($cm) && !$cm->visible && !has_capability('moodle/course:viewhiddenactivities', $cm->context)) {
+            if (!empty($cm) and (!$cm->visible || !$conditionalvisible) and !has_capability('moodle/course:viewhiddenactivities', $cm->context)) {
+            /// END CONDITIONALS
+
                 redirect($CFG->wwwroot.'/course/view.php?id='.$cm->course, get_string('activityiscurrentlyhidden'));
             }
             user_accesstime_log($COURSE->id); /// Access granted, update lastaccess times
diff -Naur moodle/local/db/access.php moodle-conditionals/local/db/access.php
--- moodle/local/db/access.php	1970-01-01 00:00:00.000000000 +0000
+++ moodle-conditionals/local/db/access.php	2009-09-16 13:38:34.000000000 +0100
@@ -0,0 +1,36 @@
+<?php
+
+$local_capabilities = array(
+
+    'moodle/local:useconditionals' => array(
+        'riskbitmask' => RISK_CONFIG,
+        'captype' => 'write',
+        'contextlevel' => CONTEXT_COURSE,
+        'legacy' => array(
+            'editingteacher' => CAP_ALLOW,
+            'admin' => CAP_ALLOW
+        )
+    ),
+
+    'moodle/local:createconditionals' => array(
+        'riskbitmask' => RISK_CONFIG,
+        'captype' => 'write',
+        'contextlevel' => CONTEXT_COURSE,
+        'legacy' => array(
+            'editingteacher' => CAP_ALLOW,
+            'admin' => CAP_ALLOW
+        )
+    ),
+
+    'moodle/local:assigncomments' => array(
+        'riskbitmask' => RISK_XSS,
+        'captype' => 'write',
+        'contextlevel' => CONTEXT_COURSE,
+        'legacy' => array(
+            'editingteacher' => CAP_ALLOW,
+            'admin' => CAP_ALLOW
+        )
+    ),
+);
+
+?>
diff -Naur moodle/local/db/upgrade.php moodle-conditionals/local/db/upgrade.php
--- moodle/local/db/upgrade.php	1970-01-01 00:00:00.000000000 +0000
+++ moodle-conditionals/local/db/upgrade.php	2009-09-16 13:38:34.000000000 +0100
@@ -0,0 +1,60 @@
+<?php
+
+function xmldb_local_upgrade($oldversion=0) {
+    //global $CFG, $db;
+ 
+    $result = true;
+
+    if ($result && $oldversion < 2009032400) {
+        $result = $result && install_from_xmldb_file(dirname(__FILE__).'/install.xml');
+
+        /// Define field info to be added to course_modules
+        $table = new XMLDBTable('course_modules');
+        $field = new XMLDBField('info');
+        $field->setAttributes(XMLDB_TYPE_TEXT, 'medium', null, null, null, null, null, null, 'groupmembersonly');
+        $result = $result && add_field($table, $field);
+        unset($field);
+        unset($table);
+    
+        /// Define field useconditionals to be added to course
+        $table = new XMLDBTable('course');
+        $field = new XMLDBField('useconditionals');
+        $field->setAttributes(XMLDB_TYPE_INTEGER, '2', XMLDB_UNSIGNED, XMLDB_NOTNULL, null, null, null, '0', 'defaultrole');
+        $result = $result && add_field($table, $field);
+        unset($field);
+        unset($table);
+
+        /// Define field uselabel to be added to course
+        $table = new XMLDBTable('course');
+        $field = new XMLDBField('uselabel');
+        $field->setAttributes(XMLDB_TYPE_INTEGER, '2', XMLDB_UNSIGNED, XMLDB_NOTNULL, null, null, null, '0', 'useconditionals');
+        $result = $result && add_field($table, $field);
+        unset($field);
+        unset($table);
+
+        /// Define field personalizedlabel to be added to course
+        $table = new XMLDBTable('course');
+        $field = new XMLDBField('personalizedlabel');
+        $field->setAttributes(XMLDB_TYPE_CHAR, '50', null, XMLDB_NOTNULL, null, null, null, null, 'uselabel');
+        $result = $result && add_field($table, $field);
+        unset($field);
+        unset($table);
+
+    }
+
+    if ($result && $oldversion < 2009090100) {
+
+        /// Define field issection to be added to conditional
+        $table = new XMLDBTable('conditional');
+        $field = new XMLDBField('issection');
+        $field->setAttributes(XMLDB_TYPE_INTEGER, '2', XMLDB_UNSIGNED, XMLDB_NOTNULL, null, null, null, '0', 'moduleid');
+
+        /// Launch add field issection
+        $result = $result && add_field($table, $field);
+
+    }
+
+    return $result;
+}
+
+?>
diff -Naur moodle/local/lang/en_utf8/local.php moodle-conditionals/local/lang/en_utf8/local.php
--- moodle/local/lang/en_utf8/local.php	1970-01-01 00:00:00.000000000 +0000
+++ moodle-conditionals/local/lang/en_utf8/local.php	2009-09-16 13:38:34.000000000 +0100
@@ -0,0 +1,7 @@
+<?php
+
+$string['local:useconditionals'] = 'Enable/disable conditionals';
+$string['local:createconditionals'] = 'Create conditionals';
+$string['local:assigncomments'] = 'Assign activity info';
+
+?>
diff -Naur moodle/local/lang/es_utf8/local.php moodle-conditionals/local/lang/es_utf8/local.php
--- moodle/local/lang/es_utf8/local.php	1970-01-01 00:00:00.000000000 +0000
+++ moodle-conditionals/local/lang/es_utf8/local.php	2009-09-16 13:38:34.000000000 +0100
@@ -0,0 +1,7 @@
+<?php
+
+$string['local:useconditionals'] = 'Activar/desactivar condicionales';
+$string['local:createconditionals'] = 'Crear condicionales';
+$string['local:assigncomments'] = 'Asignar información de actividad';
+
+?>
diff -Naur moodle/local/version.php moodle-conditionals/local/version.php
--- moodle/local/version.php	1970-01-01 00:00:00.000000000 +0000
+++ moodle-conditionals/local/version.php	2009-09-16 13:38:34.000000000 +0100
@@ -0,0 +1,5 @@
+<?php
+
+$local_version = 2009090100;
+
+?>
\ No hay ningún carácter de nueva línea al final del fichero
